SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")


local frame;
local GroupDown = false;
local GroupUp = false;
local GroupAutoActivate = false;
local loginScreen = false;
local cBDown;
local cBUp;
local cbAutoActivate;
local btnReload;
local ddmProfiles;
local info;
local raidProfile;

local function createFrame()
	frame = CreateFrame("Frame");
	frame.name = "SortGroup";
	font = frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	font:SetFont("Fonts\\FRIZQT__.TTF", 18);
	font:SetTextColor(1, 0.8, 0);
    font:SetPoint("TOPLEFT", 12, -18);
    font:SetText("Sort Group");
	InterfaceOptions_AddCategory(frame);
end

local function frameEvent()
	frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if event == ( "PLAYER_LOGOUT" ) then 
				SortGroupInformation.Down = GroupDown;
				SortGroupInformation.Up = GroupUp;
				SortGroupInformation.Profile = raidProfile;
				SortGroupInformation.AutoActivate = GroupAutoActivate;
				frame:UnregisterEvent(event);
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
				end
				
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
				end
				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = false;
				end
				
				GroupDown = SortGroupInformation.Down;
				GroupUp = SortGroupInformation.Up;
				raidProfile = SortGroupInformation.Profile;
				GroupAutoActivate = SortGroupInformation.AutoActivate;
				UIDropDownMenu_SetText(ddmProfiles, raidProfile)
				
				if ( GroupDown == true ) then
					cBDown:SetChecked(true);
					cBUp:SetChecked(false);
					GroupUp = false;
					SortBy('Down', raidProfile);
				end
				
				if ( GroupUp == true ) then
					cBDown:SetChecked(false);
					cBUp:SetChecked(true);
					GroupDown = false;
					SortBy('Up', raidProfile);
				end
				
				if ( GroupAutoActivate == true ) then
					cbAutoActivate:SetChecked(true);
				end
				frame:UnregisterEvent(event);					
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true ) then	
				loginScreen = true;
				if ( GroupDown == true ) then
					SortBy('Down', raidProfile);
				end			
				if ( GroupUp == true ) then	
					SortBy('Up', raidProfile);
				end
				frame:UnregisterEvent(event);
				frame:RegisterEvent("PLAYER_ENTERING_WORLD");
			end
		end);
end

local function createCheckbox()	
	cBDown = CreateFrame("CheckButton", "CheckButtonDown_Text", frame, "UICheckButtonTemplate");
	cBUp = CreateFrame("CheckButton", "CheckButtonUp_Text", frame, "UICheckButtonTemplate");
	cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", frame, "UICheckButtonTemplate");
	
	cBDown:SetPoint("TOPLEFT", 10, -65);
	cBUp:SetPoint("TOPLEFT",10, -100);
	cbAutoActivate:SetPoint("TOPLEFT",220,-65);
	
	getglobal(cBDown:GetName() .. 'Text'):SetText(L["cBDown_Option_Text"]);
	getglobal(cBUp:GetName() .. 'Text'):SetText(L["cBUp_Option_Text"]);
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
end

local function checkBoxEvent()
	cBDown:SetScript("OnClick",
		function()
			loginScreen = false;
			if ( cBDown:GetChecked() == true ) then
				GroupDown = true;
				GroupUp = false;
				cBUp:SetChecked(false);
				SortBy('Down', raidProfile);
			elseif ( cBDown:GetChecked() == false ) then	
				GroupDown = false;
				SortBy(nil,raidProfile);
			end
		end);		
	cBDown:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBDown_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBDown:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
		
	cBUp:SetScript("OnClick",
		function()
			loginScreen = false;
			if ( cBUp:GetChecked() == true ) then
				GroupDown = false;
				GroupUp = true;
				cBDown:SetChecked(false);
				SortBy('Up', raidProfile);
			elseif ( cBUp:GetChecked() == false ) then	
				GroupUp = false;
				SortBy(nil,raidProfile);
			end
		end);
	cBUp:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBUp_ToolTip_text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBUp:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
		
	cbAutoActivate:SetScript("OnClick",
		function()
			loginScreen = false;
			if ( cbAutoActivate:GetChecked() == true ) then
				GroupAutoActivate = true;
			if( cBDown:GetChecked() == true ) then
				SortBy('Down', raidProfile);
			elseif ( cBUp:GetChecked() == true ) then
				SortBy('Up', raidProfile);
			end
			elseif ( cbAutoActivate:GetChecked() == false ) then
				GroupAutoActivate = false;
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end

local function createButton()
	btnReload = CreateFrame("Button", "Button_Text", frame, "UIPanelButtonTemplate");
	btnReload:SetSize(84, 24);
	btnReload:SetText(L["btn_Option_text"]);
	btnReload:SetPoint("TOPLEFT", 10, -150);
end

local function buttonEvent()
	btnReload:SetScript("OnClick", 
		function()
			ReloadUI();
		end);
end

local function dropDownMenuEvent(self, arg1, arg2, checked)
	raidProfile = GetRaidProfileName(arg1);
	loginScreen = false;
	if( cBDown:GetChecked() == true ) then
		SortBy('Down',raidProfile);
	elseif (cBUp:GetChecked() == true ) then
		SortBy('Up',raidProfile);
	end
	UIDropDownMenu_SetText(ddmProfiles, raidProfile);
end

local function createDropDownMenu()
	ddmProfiles = CreateFrame("Frame", "DropDownMenuProfiles", frame, "UIDropDownMenuTemplate");
	ddmProfiles:SetPoint("TOPLEFT", 210, -110);	
end

local function createDropDownMenuText()
	UIDropDownMenu_Initialize(ddmProfiles, 
		function(self, level, menuList)
			for i=1, GetNumRaidProfiles(), 1 do
				info = UIDropDownMenu_CreateInfo();
				info.func = dropDownMenuEvent;
				info.text, info.arg1 = GetRaidProfileName(i), i;
				UIDropDownMenu_AddButton(info, level);
			end
		end);	
end


function SortDown()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end
	
function SortUp()
	CRFSort_Group = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer.flowSortFunc=CRFSort_Group;
end

function SortBy(SortOption, RaidProfileName)	
	if ( RaidProfileName ~= nil and GetNumGroupMembers() < 5 and HasLoadedCUFProfiles() == true) then
		if ( GetActiveRaidProfile() ~= RaidProfileName and GroupAutoActivate == true) then
			CompactUnitFrameProfiles_ActivateRaidProfile(RaidProfileName);
			if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
				CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);		
			end
		end
		if ( GetActiveRaidProfile() == RaidProfileName ) then
			if ( SortOption == 'Down') then
				if ( loginScreen == false ) then
					print((L["sort_down"]:gsub("'replacement'",RaidProfileName)));
				else
					loginScreen = false;
				end
				SetCVar("useCompactPartyFrames", 1);
				SortDown();
			elseif ( SortOption == 'Up') then
				if ( loginScreen == false ) then
					print((L["sort_up"]:gsub("'replacement'",RaidProfileName)));
				else
					loginScreen = false;
				end
				SetCVar("useCompactPartyFrames", 1);
				SortUp();
			end
		else
			print (L["sort_no"]);
		end		
	end
end

function GetActiveRaidProfile()
	return GetCVar("activeCUFProfile");
end

function InGroup()
	if ( GetNumGroupMembers() > 1 ) then
		print(L["Currently_in_a_group"]);
		return true;
	end
	return false;
end

createFrame();
frameEvent();
createCheckbox();
checkBoxEvent();
createButton();
buttonEvent();
createDropDownMenu();
createDropDownMenuText();